
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#include "lmuse.h"


/*extern lmuse.c*/
extern float deltaangledeg;
extern float thick;
extern unsigned rstart;
extern unsigned lastseed;
extern int randomize_p;
unsigned makeseed();
int esc_or_right_mouse_button_pressed();
/****/

int isnum (char *c);
char * formatline(char *line);

char * rules[MAXRULES];
char * rulekeys[MAXRULES];
char * rulecodes[MAXRULES];
char * replacements[MAXRULES];
char axiom[120];
char commentchar = '#';

int numrules;

FILE *rulefilefp;

int curchar;

long maxstringlength = DEFSTRINGSIZE;
char *outptr=NULL,*inptr=NULL;
char *out, *in;
char *holdptr;
char *production;
int getnextin(){
        char nextin= *inptr;
        inptr++;
        return(int) nextin;
}
void putsout(char *str){

        while (*str){
              *outptr=*str;
              outptr++;str++;
        }
        *outptr='\0';*(outptr+1)='\0';

}
#define MAXRULELINE 255

void initrules(){
    int i;
    for(i=0;i<MAXRULES;i++)
         rules[i]=NULL;
}
void reinitrules(){
    int i;
    for(i=0;i<MAXRULES;i++){
         if(rules[i]!=NULL){
               free(rules[i]);
               rules[i]=NULL;
         }
    }
}

int readrulefile(FILE *fp){
    int linenum = 0;
    int inrules=0;
    int maxlevel=0;
    int rulelength;
    char *bptr,*rptr;
    char buffer[MAXRULELINE+1];

    reinitrules();
    numrules=0;
    while(fgets(buffer,MAXRULELINE,fp)){

        formatline(buffer);
        bptr=buffer;
        if(*bptr== '@') break;/* "@" is lparser end mark*/
        if(*bptr!='\0'){
             if(isnum(bptr)){
                linenum++;
                if(linenum == 1){
                        maxlevel = atoi(bptr);
                        if(maxlevel<0) maxlevel=0;
                }
                else if(linenum == 2)
                        deltaangledeg = atof(bptr);
                else if(linenum == 3){
                        
                        if (isnum(bptr)){
                              thick = atof(bptr);

                        }


                }
             }
             else{
                if(inrules){
                   rulelength=strlen(bptr);
                   rptr=(char *) malloc(sizeof(char)*( rulelength+1));
                   if(rptr==NULL){
                        return -1;
                   }
                   strcpy(rptr,bptr);
                   rules[numrules]=rptr;
                   numrules = numrules + 1;
                }
                else{
                    inrules=1;
                    strcpy(axiom,bptr);
                }
             }
        }

    }
    return maxlevel;
}

char fileinfo[12][80];
char productionmessage[80]="";
char productionnumberstring[80];

int showprocessstatus(char *message);

int makeproduction(int maxlevel){
      int level=0;

      int rulenumber;
      int rulefound;
      int rulelength;
      char *ruleptr,*eqptr,*replace;
      char *leftptr,*rightptr;
      char leftchar='\0';
      int nextchar='\0';
      float prob;

      long slen;
      long maxlen=maxstringlength-10L;
      if(randomize_p){
         rstart=makeseed();
         lastseed=rstart;
      }
      else rstart=lastseed;
      srand(rstart);
      curchar='\0';
      sprintf(productionnumberstring,"\nProduction %d\n", level);

      if(out!=NULL){
                 free(out);
      }
      out=(char *)malloc(maxstringlength);
      if(in!=NULL){
                 free(in);
      }
      in=(char *)malloc(maxstringlength);
      if(in==NULL || out==NULL){
                  sprintf(productionmessage,"Memory Allocation Error");
                  return -1;
      }
      strcpy(in,axiom);

      inptr=in;
      outptr=out;
      for(level = 0;level< maxlevel;level++){
          slen=0L;
          sprintf(productionnumberstring,"\nMaking Production: Level %d\n", level+1);
          showprocessstatus(productionnumberstring);
          while( (curchar=getnextin())!='\0'){
             if( esc_or_right_mouse_button_pressed()){
                      production=in;
                      return 1;
             }

             rulenumber = 0;
             rulefound=0;
             while(rules[rulenumber]!=NULL){
                 ruleptr=rules[rulenumber];
                 rulelength=strlen(ruleptr);
                 if (curchar==(unsigned char)*ruleptr){
                    /* this rule matches current character*/
                    eqptr=strchr(ruleptr,'=');
                    replace=eqptr+1;

                    ruleptr++;

                    if(*ruleptr=='<'){
                           ruleptr++;
                           if(leftchar==')'){
                                     leftptr=inptr-3;
                                     while(*leftptr!='(')
                                        leftptr--;
                                     leftptr--;
                                     leftchar=*leftptr;
                           }

                           if(*ruleptr!=leftchar){
                                rulenumber++;
                                continue;
                           }
                           ruleptr++;
                    }
                    if(*ruleptr=='>'){
                           ruleptr++;
                           nextchar=*inptr;
                           if(nextchar=='('){
                               rightptr=inptr+1;
                               while(*rightptr != ')' && *rightptr != '\0'){
                                    rightptr++;
                               }
                               if(*rightptr !='\0')
                                   rightptr++;
                               nextchar=*rightptr;
                           }
                           if(*ruleptr!=nextchar){
                                rulenumber++;
                                continue;
                           }
                           ruleptr++;
                    }
                    if(*ruleptr=='('){
                         ruleptr++;
                         prob=atof(ruleptr);
                         if(RND>prob){
                                rulenumber++;
                                continue;

                         }
                         ruleptr=strchr(ruleptr,')');
                         if(ruleptr==NULL||strlen(ruleptr)<strlen(replace)){
                             sprintf(productionmessage,"Badly formed stochastic rule");
                             return -1;
                         }
                         ruleptr++;

                    }
                    
                    slen+=strlen(replace);
                    if(slen>maxlen){
                        sprintf(productionmessage,"Ran out of string space");
                        return -1;
                    }
                    putsout(replace);
                    rulefound = 1;
                    break;
                 }/* end of if(curchar==*ruleptr)*/
                 rulenumber++;

             }
             if(rulefound==0){
                 slen++;
                 if(slen>maxlen){
                      sprintf(productionmessage,"Ran out of string space");
                      return -1;
                 }
                 *outptr=curchar;
                 outptr++;*outptr='\0';*(outptr+1)='\0';

             }


             leftchar=curchar;
          }
          holdptr=in;
          in=out;
          out=holdptr;

          inptr=in; outptr=out;
       }  /* next level*/
       production=in;
       return 0;
}

char *formatline(char *line){
/*remove *all* spaces, and truncate at comment*/
   char *lptr,*xptr,*yptr;

   lptr=line;
   while(*lptr!='\0'){
        if(*lptr==commentchar||*lptr=='\n')
             *lptr='\0';
        else if(isspace(*lptr)){
             xptr=lptr;
             yptr=xptr+1;
             while(*xptr!='\0'){
                  *xptr=*yptr;
                  xptr++;yptr++;
             }
        }
        else lptr++;
   }
   return line;
}

int isnum (char *c){
        int c1 = *c-'0';
        if (c1 >=0 && c1 <=9)  return(1);
        if(*c=='-' || *c=='+' || *c=='.'){
               c1 = *(c+1)-'0';
               if (c1 >=0 && c1 <=9)  return(1);
               if(c1 == '.'){
                     c1 = *(c+2)-'0';
                     if (c1 >=0 && c1 <=9)  return(1);
               }
        }
        return(0);
}


int L_mutate(void)  /* adapted from lparser.c, Laurens Lapre */
{
    int      i, k, ii, max = 1000;
    unsigned int j;
    char     T, R, S[10] = "";
    char     rulet[400] = "";
    int      t;
    char     * replacements[MAXRULES];
    char     * tempptr;
    char     * s;
    int      nrules=0;
    for (i = 0; i < MAXRULES; i++) {
        if (rules[i] == NULL)
            break;
        replacements[i]=strchr(rules[i],'=');
        replacements[i]++;
        nrules++;
    }

    if(nrules<1) return -1;
    switch (RANDOM( 6)) {

      default:
        return 0;

      case 1:                              /* Insert */
        i = RANDOM(nrules);
        /*T = replacements[i][0];*/
        T= rules[i][0];
        j = RANDOM(nrules);

        if(strlen(replacements[j])<1)
             return 0;
        k = RANDOM( strlen(replacements[j]));
        k = (k < 1) ? 1 : k;
        if(strlen(&(replacements[j][k]))>390)
             return 0;
        strcpy(rulet, &(replacements[j][k]));
        tempptr=(char *) malloc(sizeof(char)*(strlen(rules[j])+4));
        if(tempptr==NULL)
                         return -1;
        strcpy (tempptr,rules[j]);
        free(rules[j]);
        rules[j]=tempptr;
        replacements[j]=(strchr(rules[j],'='))+1;
        if(RND<.33){
           replacements[j][k]     = '\\';
           replacements[j][k + 1] = T;
           replacements[j][k + 2] = '/';
        }
        else if(RND<.5){
           replacements[j][k]     = '[';
           replacements[j][k + 1] = T;
           replacements[j][k + 2] = ']';
        }
        else{
           replacements[j][k]     = '{';
           replacements[j][k + 1] = T;
           replacements[j][k + 2] = '}';
        }
        replacements[j][k + 3] = '\0';
        strcat(rules[j], rulet);
        return 1;

        break;

      case 0:
        i = RANDOM(nrules);
        T = replacements[i][0];
        if(strchr("[]{}",T)!=NULL) return 0;
        j = RANDOM(nrules);

        if(strlen(replacements[j])<1)
             return 0;
        k = RANDOM( strlen(replacements[j]));
        k = (k < 1) ? 1 : k;
        if(strlen(&(replacements[j][k]))>390)
             return 0;
        strcpy(rulet, &(replacements[j][k]));
        tempptr=(char *) malloc(sizeof(char)*(strlen(rules[j])+4));
        if(tempptr==NULL)
                         return -1;
        strcpy (tempptr,rules[j]);
        free(rules[j]);
        rules[j]=tempptr;
        replacements[j]=(strchr(rules[j],'='))+1;
        if(RND<.5){
        replacements[j][k]     = '[';
        replacements[j][k + 1] = T;
        replacements[j][k + 2] = ']';
        }
        else{
        replacements[j][k]     = '{';
        replacements[j][k + 1] = T;
        replacements[j][k + 2] = '}';
        }
        replacements[j][k + 3] = '\0';
        strcat(rules[j], rulet);
        return 1;

        break;
      case 2:
        t=0;/* Replace */
        do {
            i = RANDOM(nrules);
            j = RANDOM(nrules);
            T = replacements[i][0];
            R = replacements[j][0];
            S[0]=T;S[1]=R;S[2]='\0';
            t++;
            if(t>100) return 0;
        } while (T == R || strcspn(S,"[]{}()")!=2);
        for (ii = 0; ii < max; ii++) {
            i = RANDOM(nrules);
            for (j = 0; j < strlen(replacements[i]); j++) {
                if (replacements[i][j] == T) {
                    replacements[i][j] = R;
                    return 1;
                }
            }
        }
        return 0;
        break;

      case 3:                              /* Append */
        i = RANDOM(nrules);
        s = replacements[i];
        j = RANDOM(nrules);

        tempptr=(char *)malloc(strlen(rules[j])+strlen(replacements[i])+1);
        if(tempptr==NULL)
                         return -1;
        strcpy(tempptr,rules[j]);
        free(rules[j]);
        rules[j]=tempptr;
        strcat(rules[j], s);
        return 1;
        /*size[i] = strlen(rule[i]) - 2;*/
        break;

      case 4:                              /* Swap directions */
        for (ii = 0; ii < max; ii++) {
            i = RANDOM(nrules);
            for (j = 2; j < strlen(replacements[i]); j++) {
                switch (RANDOM(12)) {
                  default:
                    return 0;
                  case 0:
                    if (replacements[i][j] == '+') {
                        replacements[i][j] = '-';
                        return 1;
                    }
                    break;
                  case 1:
                    if (replacements[i][j] == '-') {
                        replacements[i][j] = '+';
                        return 1;
                    }
                    break;
                  case 2:
                    if (replacements[i][j] == '&') {
                        replacements[i][j] = '^';
                        return 1;
                    }
                    break;
                  case 3:
                    if (replacements[i][j] == '^') {
                        replacements[i][j] = '&';
                        return 1;
                    }
                    break;
                  case 4:
                    if (replacements[i][j] == '>') {
                        replacements[i][j] = '<';
                        return 1;
                    }
                    break;
                  case 5:
                    if (replacements[i][j] == '<') {
                        replacements[i][j] = '>';
                        return 1;
                    }
                    break;
                  case 6:
                    if (replacements[i][j] == '|') {
                        replacements[i][j] = '%';
                        return 1;
                    }
                    break;
                  case 7:
                    if (replacements[i][j] == '%') {
                        replacements[i][j] = '|';
                        return 1;
                    }
                    break;
                  case 8:
                    if (replacements[i][j] == ':') {
                        replacements[i][j] = ';';
                        return 1;
                    }
                    break;
                  case 9:
                    if (replacements[i][j] == ';') {
                        replacements[i][j] = ':';
                        return 1;
                    }
                    break;
                  case 10:
                    if (replacements[i][j] == '\'') {
                        replacements[i][j] = '\"';
                        return 1;
                    }
                    break;
                  case 11:
                    if (replacements[i][j] == '\"') {
                        replacements[i][j] = '\'';
                        return 1;
                    }
                    break;
                }
            }
        }
        break;

      case 5:                              /* Swap sizes */
        for (ii = 0; ii < max; ii++) {
            i = RANDOM(nrules);
            for (j = 2; j < strlen(replacements[i]); j++) {
                switch (RANDOM(6)) {
                  default:
                    return 0;
                  case 0:
                    if (replacements[i][j] == 'F') {
                        replacements[i][j] = 'Z';
                        return 1;
                    }
                    break;
                  case 1:
                    if (replacements[i][j] == 'Z') {
                        replacements[i][j] = 'F';
                        return 1;
                    }
                    break;
                  case 2:
                    if (replacements[i][j] == 'f') {
                        replacements[i][j] = 'z';
                        return 1;
                    }
                    break;
                  case 3:
                    if (replacements[i][j] == 'z') {
                        replacements[i][j] = 'f';
                        return 1;
                    }
                    break;
                  case 4:
                    if (replacements[i][j] == '!') {
                        replacements[i][j] = '?';
                        return 1;
                    }
                    break;
                  case 5:
                    if (replacements[i][j] == '?') {
                        replacements[i][j] = '!';
                        return 1;
                    }
                    break;
                }
            }
        }
        break;

    }
    return 0;
}

